"use strict";
/*
eslint-disable max-classes-per-file
*/
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UUIDPK = exports.ModelAssertionError = exports.HyperModelError = exports.HyperModel = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
class HyperModel extends sequelize_typescript_1.Model {
    static exists(options) {
        return __awaiter(this, void 0, void 0, function* () {
            const c = yield this.count(options);
            return c !== 0;
        });
    }
}
exports.HyperModel = HyperModel;
class HyperModelError extends Error {
    constructor(message) {
        super(message);
        this.isModelError = true;
        Object.setPrototypeOf(this, new.target.prototype);
    }
}
exports.HyperModelError = HyperModelError;
class ModelAssertionError extends Error {
    constructor(message) {
        super(message);
        this.isAssertionError = true;
        Object.setPrototypeOf(this, new.target.prototype);
    }
}
exports.ModelAssertionError = ModelAssertionError;
function UUIDPK(t, prop) {
    (0, sequelize_typescript_1.Column)(t, prop);
    (0, sequelize_typescript_1.PrimaryKey)(t, prop);
    (0, sequelize_typescript_1.IsUUID)(4)(t, prop);
    (0, sequelize_typescript_1.AllowNull)(false)(t, prop);
    (0, sequelize_typescript_1.Default)(sequelize_typescript_1.DataType.UUIDV4)(t, prop);
}
exports.UUIDPK = UUIDPK;
